#include <stdio.h>
#include <math.h>
#include <graphics.h>
#include <dos.h>
#include <conio.h>
#define NOTHING 0
#define TARGET_DESTROYED 1
#define CAPITOLY_DESTROYED 2
float VT0=6, VM0=8;      //module of start target and missile velocities
const left=0, top=100, right=500, bottom=479;
float YMax, XMax;
int gdriver = VGA, gmode = VGAHI;
char Msg[][70]={
   "",
   "Bin Laden's missile destroyed. Congratulations, Mr. President!",
   "Your Capitoly destroyed. You dead under 20m of beton pieces..."
};
//--------------------------------------------------------------------------
class vector{
public:
   float x,y;
   vector(float ax=0, float ay=0){
       x=ax;
       y=ay;
   }
   float mod(){
      return( sqrt(x*x+y*y) );
   }
};
vector operator+(vector a, vector b){
   vector c;
   c.x = a.x + b.x;
   c.y = a.y + b.y;
   return(c);
}
vector operator-(vector a, vector b){
   vector c;
   c.x = a.x - b.x;
   c.y = a.y - b.y;
   return(c);
}
vector operator*(float a, vector b){
   vector c;
   c.x = a * b.x;
   c.y = a * b.y;
   return(c);
}
vector operator*(vector a, float b){
   vector c;
   c.x = a.x * b;
   c.y = a.y * b;
   return(c);
}
vector operator/(vector a, float b){
   vector c;
   c.x = a.x / b;
   c.y = a.y / b;
   return(c);
}

//-------------------------------------------------------------------------
void DrawScreen(){
   rectangle(left, top, right, bottom);
   //rectangle(right, top, 639, bottom);
   rectangle( (right+left)/2, bottom - (bottom-top)/5, right, bottom);
   arc(left+(right-left)*3/4, bottom - (bottom-top)/5, 0, 180, (right-left)/8);
   return;
}
void DrawTarget(vector RT){
   putpixel( left + RT.x/XMax * (right-left), top + (bottom-top)*(1 - RT.y/YMax),  GREEN );
   return;
}
void DrawMissile(vector RM){
   putpixel( left + RM.x/XMax * (right-left), top + (bottom-top)*(1 - RM.y/YMax),  RED );
   return;
}
vector f(vector RT, vector RM, vector VT, float dt){
   vector Res;
   vector RTdt = RT + VT*dt;
   vector Dif = RTdt - RM;
   Res = VM0 * Dif/Dif.mod();
   return(Res);
}
int CheckCoords(vector RT, vector RM){
   //஢,    ⭮襭 ﭨ  ࠪ⠬
   // ࠪ ࠧ஬  XMax 祭 
   vector Dif = RT-RM;
   float Frac = Dif.mod() / XMax;
   if( Frac <= 1e-3){
       return(TARGET_DESTROYED);
   }
   //஢,  㯠  楫 (ࠦ᪠ ࠪ)  ६
   //..  ࠢ  .
   if(RT.y < 0 && RT.x > XMax / 2){
       return(CAPITOLY_DESTROYED);
   }
   return(NOTHING);
}
void ShowMsgAndSound(int MsgType){
   //settextstyle(TRIPLEX_FONT, HORIZ_DIR, 1);
   settextstyle(SANS_SERIF_FONT, HORIZ_DIR, 1);

   setusercharsize(1,2,1,1);
   settextjustify(CENTER_TEXT, CENTER_TEXT);
   outtextxy((left+right)/2, (top+bottom)/2, Msg[MsgType] );
   /*switch(MsgType){
       case TARGET_DESTROYED:
	sound(200);
	delay(300);
	sound(400);
	delay(300);
	sound(500);
	delay(300);
	sound(600);
	delay(450);
	nosound();
	break;
       case CAPITOLY_DESTROYED:
	sound(480);
	delay(300);
	sound(400);
	delay(300);
	sound(250);
	delay(300);
	sound(200);
	delay(450);
	nosound();
	break;
   } */
}
//-------------------------------------------------------------------------
void main(){
   float G=10;

   YMax = VT0*VT0/(2*G);
   XMax = VT0*VT0/G;

   vector RT(0, 0), VT;
   vector RM(XMax/2.0, 0), VM;
   vector k1, k2, k3, k4, k;
   float angle = 60.0;
   angle = M_PI/180.0 * angle;
   float t, dt=0.001;

   VT.x = VT0 * cos(angle);
   VT.y = VT0 * sin(angle);

   initgraph(&gdriver, &gmode, "");
   DrawScreen();
   for(t=0; RT.y >= 0 ; t+=dt){
       //calculate target coords
       VT.y = VT.y - G*dt;
       RT = RT + VT*dt;
       //calculate missile coords
       k1 = f(RT,        RM, VT, 0) * dt;
       k2 = f(RT + k1/2, RM, VT, dt/2) * dt;
       k3 = f(RT + k2/2, RM, VT, dt/2) * dt;
       k4 = f(RT + k3,   RM, VT, dt) * dt;
       k = 1.0/6.0 * (k1 + 2*k2 + 2*k3 + k4);
       RM = RM + k;
       //draw target and missile
       DrawTarget(RT);
       DrawMissile(RM);
       //check for
       int CheckResult = CheckCoords(RT, RM);
       if(CheckResult!=NOTHING){
	   ShowMsgAndSound(CheckResult);
	   break;
       }
       //delay(2);
   }
   getch();
   closegraph();
   return;
}